// AD&D Easy Character Generator
// by Martin Klein-Hennig
// Created 16.08.01; 16:24:52

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

short _ti89;                  // Produce .89Z File

// Global variables for the user's ability scores
int strength=0,dexterity=0,constitution=0,intelligence=0,wisdom=0,charisma=0;
int aussergew=0,realstr=0;

// "aussergew" is short for "Aussergewhnliche Strke"
// it means exceptional strength in German :)


// My favourite for() variable: i!

i=0;

// These are the values which you can find in the AD&D rules

char *strtrefferchance[30]={"-5","-3","-3","-2","-2","-1","-1","Normal","Normal","Normal","Normal","Normal","Normal","Normal","Normal","Normal","+1","+1","+3","+3","+4","+4","+5","+6","+7","+1","+2","+2","+2","+3"};
char *strschadensmodifikation[30]={"-4","-2","-1","-1","-1","None","None","None","None","None","None","None","None","None","None","+1","+1","+2","+7","+8","+9","+10","+11","+12","+14","+3","+3","+4","+5","+6"};
char *strtraglast[30]={"1","1","5","10","10","20","20","35","35","40","40","45","45","55","55","70","85","110","485","535","635","785","935","1235","1535","135","160","185","235","335"};
char *strstemm[30]={"3","5","10","25","25","55","55","90","90","115","115","140","140","170","170","195","220","255","640","700","810","970","1130","1440","1750","280","305","330","380","480"};
char *strtueren[30]={"1","1","2","3","3","4","4","5","5","6","6","7","7","8","8","9","10","11","16(8)","17(10)","17(12)","18(14)","18(16)","19(17)","19(18)","12","13","14","15(3)","16(6)"};
char *strstangen[30]={"0%","0%","0%","0%","0%","0%","0%","1%","1%","2%","2%","4%","4%","7%","7%","10%","13%","16%","50%","60%","70%","80%","90%","95%","99%","20%","25%","30%","35%","40%"};
char *dexreaktion[25]={"-6","-4","-3","-2","-1","0","0","0","0","0","0","0","0","0","0","+1","+2","+2","+3","+3","+4","+4","+4","+5","+5"};
char *dexfernwaffen[25]={"-6","-4","-3","-2","-1","0","0","0","0","0","0","0","0","0","0","+1","+2","+2","+3","+3","+4","+4","+4","+5","+5"};
char *dexausweich[25]={"+5","+5","+4","+3","+2","+1","0","0","0","0","0","0","0","0","-1","-2","-3","-4","-4","-4","-5","-5","-5","-6","-6"};
char *contrefferpunkte[25]={"-3","-2","-2","-1","-1","-1","0","0","0","0","0","0","0","0","+1","+2","+2 (+3)","+2 (+4)","+2 (+5)","+2 (+5)","+2 (+6)","+2 (+6)","+2 (+6)","+2 (+7)","+2 (+7)"};
char *conschock[25]={"25%","30%","35%","40%","45%","50%","55%","60%","65%","70%","75%","80%","85%","88%","90%","95%","97%","99%","99%","99%","99%","99%","99%","99%","100%"};
char *conwieder[25]={"30%","35%","40%","45%","50%","55%","60%","65%","70%","75%","80%","85%","90%","92%","94%","96%","98%","100%","100%","100%","100%","100%","100%","100%","100%"};
char *congift[25]={"-2","-1","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","+1","+1","+2","+2","+3","+3","+4"};
char *conreg[25]={"None","None","None","None","None","None","None","None","None","None","None","None","None","None","None","None","None","None","None","1/6 turns","1/5 turns","1/4 turns","1/3 turns","1/2 turns","1/1 turn"};
char *intsprachen[25]={"0","1","1","1","1","1","1","1","2","2","2","3","3","4","4","5","6","7","8","9","10","11","12","15","20"};
char *intzaubergrad[25]={"-","-","-","-","-","-","-","-","Four","Five","Five","Six","Six","Seven","Seven","Eight","Eight","Nine","Nine","Nine","Nine","Nine","Nine","Nine","Nine"};
char *intchance[25]={"-","-","-","-","-","-","-","-","35%","40%","45%","50%","55%","60%","65%","70%","75%","85%","95%","96%","97%","98%","99%","100%","100%"};
char *inthoechstzahl[25]={"-","-","-","-","-","-","-","-","6","7","7","7","9","9","11","11","14","18","All","All","All","All","All","All","All"};
char *intimmunillu[25]={"-","-","-","-","-","-","-","-","-","-","-","-","-","-","-","-","-","-","1st-level","2nd-level","3rd-level","4th-level","5th-level","6th-level","7th-level"};
char *wismodmagie[25]={"-6","-4","-3","-2","-1","-1","-1","0","0","0","0","0","0","0","+1","+2","+3","+4","+4","+4","+4","+4","+4","+4","+4"};
char *wiszusatz[25]={"-","-","-","-","-","-","-","-","0","0","0","0","1. Grad","1st","2nd","2nd","3rd","4th","1st+4th","2nd+4th","3rd+5th","4th+5th","1st+6th","5th+6th","6th+7th"};
char *wisversag[25]={"80%","60%","50%","45%","40%","35%","30%","25%","20%","15%","10%","5%","0%","0%","0%","0%","0%","0%","0%","0%","0%","0%","0%","0%","0%"};
char *wisimmun[7]={"Cause Fear\nCharm Person\nCommand\nFriends\nHypnotism\n","Forget\nHold Person\nRay of Enfeeblement\nScare\n","Fear\n","Charm Monster\nConfusion\nEmotion\nFumble\nSuggestion\n","Chaos\nFeeblemind\nHold Monster\nMagic Jar\nQuest\n","Geas\nMass Suggestion\nRod of Rulership\n","Antipathy/Sympathy\nDeath Spell\nMass Charm\n"};
char *chagefolg[25]={"0","1","1","1","2","2","3","3","4","4","4","5","5","6","7","8","10","15","20","25","30","35","40","45","50"};
char *chaloyal[25]={"-8","-7","-6","-5","-4","-3","-2","-1","0","0","0","0","0","+1","+3","+4","+6","+8","+10","+12","+14","+16","+18","+20","+20"};
char *chareak[25]={"-7","-6","-5","-4","-3","-2","-1","0","0","0","0","0","+1","+2","+3","+5","+6","+7","+8","+9","+10","+11","+12","+13","+14"};

/*
* Self-made input routine which converts user input into an integer
* prompt is the string to be displayed while waiting for input
*/

int inputint(char *prompt, int min, int max)
{
	char pinput[20];
	int result=-1;
	while (result<min||result>max)
	{
		printf("%s",prompt);
		result=atoi(gets(pinput));	
	}
	return result;
}

/* 
* This is the nice text-mode "splash screen"
* Made with figlet
*/

void startScreen()
{
	clrscr();
	FontSetSys(F_8x10);
	printf("        _     _\n");
	printf("    /\\ | \\() | \\\n");
	printf("   /--\\|_/(_X|_/\n");
	printf("   -------------\n");
	printf("    EasyCharGen\n");
	printf("    by MartinKH\n");
	printf("     Enjoy....\n");
	ngetchx();
	FontSetSys(F_6x8);
	clrscr();	
}

/*
* This function displays the values according to the user's ability scores
*/

void outputValues()
{
	clrscr();
	if (aussergew>0)
		printf("Strength:%i/%i\n",realstr,aussergew);
	else
		printf("Strength:%i\n",realstr);
	printf("-------------------------\n");
	printf("\nHit Propability: %s",strtrefferchance[strength-1]);
	printf("\nDamage Adjustment: %s",strschadensmodifikation[strength-1]);
	printf("\nWeight Allowance: %s",strtraglast[strength-1]);
	printf("\nMaximum Press: %s",strstemm[strength-1]);
	printf("\nOpen Doors: %s",strtueren[strength-1]);
	printf("\nBend Bars/Lift Gates: %s",strstangen[strength-1]);
	ngetchx();
	clrscr();
	printf("Dexterity:%i\n",dexterity);
	printf("-------------------------\n");
	printf("\nReaction Adjustment: %s",dexreaktion[dexterity-1]);
	printf("\nMissile Attack Adj.: %s",dexfernwaffen[dexterity-1]);
	printf("\nDefensive Adjustment: %s",dexausweich[dexterity-1]);
	ngetchx();
	clrscr();
	printf("Constitution: %i\n",constitution);
	printf("-------------------------\n");
	printf("\nHit Point Adj.: %s",contrefferpunkte[constitution-1]);
	printf("\nSystem Shock: %s",conschock[constitution-1]);
	printf("\nResurrection Surv.: %s",conwieder[constitution-1]);
	printf("\nPoison Save: %s",congift[constitution-1]);
	printf("\nRegeneration: %s",conreg[constitution-1]);
	ngetchx();
	clrscr();
	printf("Intelligence: %i\n",intelligence);
	printf("-------------------------\n");
	printf("\nNo. of Languages: %s",intsprachen[intelligence-1]);
	printf("\nSpell Level: %s",intzaubergrad[intelligence-1]);
	printf("\nChance to Learn Spl.: %s",intchance[intelligence-1]);
	printf("\nMax. of Spells/Lvl: %s",inthoechstzahl[intelligence-1]);
	printf("\nSpell Immunity: %s",intimmunillu[intelligence-1]);
	ngetchx();
	clrscr();
	printf("Wisdom: %i\n",wisdom);
	printf("-------------------------\n");
	printf("\nMag. Def. Adjustment: %s",wismodmagie[wisdom-1]);
	printf("\nBonus Spells: %s",wiszusatz[wisdom-1]);
	printf("\nChance of Failure: %s",wisversag[wisdom-1]);

/*
* Output the player's spell immunity (eventually uses several pages)
*/

	if (wisdom<=18)
		printf("\nSpell Immunity: -\n");
	ngetchx();
	if (wisdom>18)
	{
		for (i=0;i<wisdom-18;i++)
		{
			clrscr();
			printf("Spell Immunity:\n%s",wisimmun[i]);
			ngetchx();
		}
	}
	clrscr();
	printf("Charisma: %i\n",charisma);
	printf("-------------------------\n");
	printf("\nMax. Henchmen: %s",chagefolg[charisma-1]);
	printf("\nLoyalty Base: %s",chaloyal[charisma-1]);
	printf("\nReaction Adjustment: %s",chareak[charisma-1]);
	ngetchx();
}

/*
* This function gets the user's ability scores. It uses the function inputint
*/

void inputStats()
{
	strength=inputint("Strength:",1,25);
	realstr=strength;

/*
* Ask for exceptional strength
*/

	if (strength==18)
	{
		aussergew=inputint("Exceptional Strength:",0,100);
	}
	if (aussergew>=1&&aussergew <=50)
		strength=26;
	if (aussergew>=51&&aussergew<=75)
		strength=27;
	if (aussergew>=76&&aussergew<=90)
		strength=28;
	if (aussergew>=91&&aussergew<=99)
		strength=29;
	if (aussergew==100)
		strength=30;

	dexterity=inputint("Dexterity: ",1,25);
	constitution=inputint("Constitution: ",1,25);
	intelligence=inputint("Intelligence: ",1,25);
	wisdom=inputint("Wisdom: ",1,25);
	charisma=inputint("Charisma: ",1,25);
}

/*
* Main function
*/

void _main(void)
{
	strength=0,dexterity=0,constitution=0,intelligence=0,wisdom=0,charisma=0,i=0;
	aussergew=0,realstr=0;
	startScreen();
	inputStats();
	outputValues();
}

